Index: palm/trunk/SOURCE/advec_s_bc.f90
===================================================================
--- palm/trunk/SOURCE/advec_s_bc.f90	(revision 1959)
+++ palm/trunk/SOURCE/advec_s_bc.f90	(revision 1960)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! New CASE statement to treat scalars and humidity separately
 ! 
 ! Former revisions:
@@ -120,7 +120,7 @@
 
        USE control_parameters,                                                    &
-           ONLY:  dt_3d, bc_pt_t_val, bc_q_t_val, ibc_pt_b, ibc_pt_t, ibc_q_t,    &
-                  message_string, pt_slope_offset, sloping_surface, u_gtrans,     &
-                  v_gtrans
+           ONLY:  dt_3d, bc_pt_t_val, bc_q_t_val, bc_s_t_val, ibc_pt_b, ibc_pt_t, &
+                  ibc_q_t, ibc_s_t, message_string, pt_slope_offset,              &
+                  sloping_surface, u_gtrans, v_gtrans
 
        USE cpulog,                                                                &
@@ -969,4 +969,40 @@
           ENDIF
 
+       ELSEIF ( sk_char == 's' )  THEN
+!
+!--       Specific scalar boundary condition at the bottom boundary.
+!--       Dirichlet (fixed surface humidity) or Neumann (i.e. zero gradient)
+          DO  i = nxl, nxr
+             DO  j = nys, nyn
+                sk_p(nzb,j,i)   = sk_p(nzb+1,j,i)
+                sk_p(nzb-1,j,i) = sk_p(nzb,j,i)
+                sk_p(nzb-2,j,i) = sk_p(nzb,j,i)
+             ENDDO
+          ENDDO
+
+!
+!--       Specific scalar boundary condition at the top boundary
+          IF ( ibc_s_t == 0 )  THEN
+!
+!--          Dirichlet
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   sk_p(nzt+2,j,i)   = sk_p(nzt+1,j,i)
+                   sk_p(nzt+3,j,i)   = sk_p(nzt+1,j,i)
+                ENDDO
+             ENDDO
+
+          ELSE
+!
+!--          Neumann: dzu(nzt+2:3) are not defined, dzu(nzt+1) is used instead
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   sk_p(nzt+2,j,i)   = sk_p(nzt+1,j,i) + bc_s_t_val * dzu(nzt+1)
+                   sk_p(nzt+3,j,i)   = sk_p(nzt+2,j,i) + bc_s_t_val * dzu(nzt+1)
+                ENDDO
+             ENDDO
+
+          ENDIF
+
        ELSEIF ( sk_char == 'qr' )  THEN
 
Index: palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- palm/trunk/SOURCE/advec_ws.f90	(revision 1959)
+++ palm/trunk/SOURCE/advec_ws.f90	(revision 1960)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! Separate humidity and passive scalar
 ! 
 ! Former revisions:
@@ -228,10 +228,11 @@
        USE arrays_3d,                                                          &
            ONLY:  diss_l_e, diss_l_nr, diss_l_pt, diss_l_q, diss_l_qr,         &
-                  diss_l_sa, diss_l_u, diss_l_v, diss_l_w,  flux_l_e,          &
-                  flux_l_nr, flux_l_pt, flux_l_q, flux_l_qr, flux_l_sa,        &
-                  flux_l_u, flux_l_v, flux_l_w, diss_s_e, diss_s_nr, diss_s_pt,&
-                  diss_s_q, diss_s_qr, diss_s_sa, diss_s_u, diss_s_v, diss_s_w,& 
-                  flux_s_e, flux_s_nr, flux_s_pt, flux_s_q, flux_s_qr,         &
-                  flux_s_sa, flux_s_u, flux_s_v, flux_s_w
+                  diss_l_s, diss_l_sa, diss_l_u, diss_l_v, diss_l_w,  flux_l_e,&
+                  flux_l_nr, flux_l_pt, flux_l_q, flux_l_qr, flux_l_s,         &
+                  flux_l_sa, flux_l_u, flux_l_v, flux_l_w, diss_s_e, diss_s_nr,&
+                  diss_s_pt, diss_s_q, diss_s_qr, diss_s_s, diss_s_sa,         &
+                  diss_s_u, diss_s_v, diss_s_w, flux_s_e, flux_s_nr, flux_s_pt,&
+                  flux_s_q, flux_s_qr, flux_s_s, flux_s_sa, flux_s_u, flux_s_v,&
+                  flux_s_w
 
        USE constants,                                                          &
@@ -254,5 +255,6 @@
            ONLY:  sums_us2_ws_l, sums_vs2_ws_l, sums_ws2_ws_l, sums_wsnrs_ws_l,&
                   sums_wspts_ws_l, sums_wsqrs_ws_l, sums_wsqs_ws_l,            &
-                  sums_wssas_ws_l,  sums_wsus_ws_l, sums_wsvs_ws_l  
+                  sums_wsss_ws_l, sums_wssas_ws_l,  sums_wsss_ws_l,               &
+                  sums_wsus_ws_l, sums_wsvs_ws_l  
 
 !
@@ -287,7 +289,12 @@
           sums_wspts_ws_l = 0.0_wp
 
-          IF ( humidity  .OR.  passive_scalar )  THEN
+          IF ( humidity  )  THEN
              ALLOCATE( sums_wsqs_ws_l(nzb:nzt+1,0:threads_per_task-1) )
              sums_wsqs_ws_l = 0.0_wp
+          ENDIF
+          
+          IF ( passive_scalar )  THEN
+             ALLOCATE( sums_wsss_ws_l(nzb:nzt+1,0:threads_per_task-1) )
+             sums_wsss_ws_l = 0.0_wp
           ENDIF
 
@@ -341,5 +348,5 @@
                        diss_l_e(nzb+1:nzt,nys:nyn,0:threads_per_task-1) )
 
-             IF ( humidity  .OR.  passive_scalar )  THEN
+             IF ( humidity )  THEN
                 ALLOCATE( flux_s_q(nzb+1:nzt,0:threads_per_task-1),            &
                           diss_s_q(nzb+1:nzt,0:threads_per_task-1) )
@@ -347,4 +354,11 @@
                           diss_l_q(nzb+1:nzt,nys:nyn,0:threads_per_task-1) )
              ENDIF
+             
+             IF ( passive_scalar )  THEN
+                ALLOCATE( flux_s_s(nzb+1:nzt,0:threads_per_task-1),            &
+                          diss_s_s(nzb+1:nzt,0:threads_per_task-1) )
+                ALLOCATE( flux_l_s(nzb+1:nzt,nys:nyn,0:threads_per_task-1),    &
+                          diss_l_s(nzb+1:nzt,nys:nyn,0:threads_per_task-1) )
+             ENDIF             
 
              IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
@@ -837,5 +851,6 @@
            ONLY:  sums_us2_ws_l, sums_vs2_ws_l, sums_ws2_ws_l, sums_wsnrs_ws_l,&
                   sums_wspts_ws_l, sums_wsqrs_ws_l, sums_wsqs_ws_l,            &
-                  sums_wssas_ws_l,  sums_wsus_ws_l, sums_wsvs_ws_l  
+                  sums_wsss_ws_l, sums_wssas_ws_l,  sums_wsus_ws_l,            &
+                  sums_wsvs_ws_l  
 
        IMPLICIT NONE
@@ -854,5 +869,6 @@
        IF ( ws_scheme_sca )  THEN
           sums_wspts_ws_l = 0.0_wp
-          IF ( humidity  .OR.  passive_scalar )  sums_wsqs_ws_l = 0.0_wp
+          IF ( humidity       )  sums_wsqs_ws_l = 0.0_wp
+          IF ( passive_scalar )  sums_wsss_ws_l = 0.0_wp
           IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
              sums_wsqrs_ws_l = 0.0_wp
@@ -898,5 +914,6 @@
        USE statistics,                                                         &
            ONLY:  sums_wsnrs_ws_l, sums_wspts_ws_l, sums_wsqrs_ws_l,           &
-                  sums_wsqs_ws_l, sums_wssas_ws_l, weight_substep
+                  sums_wsqs_ws_l, sums_wssas_ws_l, sums_wsss_ws_l,             &
+                  weight_substep
 
        IMPLICIT NONE
@@ -1665,4 +1682,12 @@
                                * weight_substep(intermediate_timestep_count)
              ENDDO
+             
+          CASE ( 's' )
+          
+             DO  k = nzb, nzt
+                sums_wsss_ws_l(k,tn)  = sums_wsss_ws_l(k,tn) +                &
+                                      ( flux_t(k) + diss_t(k) )               &
+                               * weight_substep(intermediate_timestep_count)
+             ENDDO
 
          END SELECT
@@ -3120,5 +3145,6 @@
        USE statistics,                                                        &
            ONLY:  sums_wspts_ws_l, sums_wsqs_ws_l, sums_wssas_ws_l,           &
-                  sums_wsqrs_ws_l, sums_wsnrs_ws_l, weight_substep
+                  sums_wsqrs_ws_l, sums_wsnrs_ws_l, sums_wsss_ws_l,           &
+                  weight_substep
 
        IMPLICIT NONE
@@ -3866,4 +3892,11 @@
                         *   weight_substep(intermediate_timestep_count)
                     ENDDO
+                 CASE ( 's' )
+                    DO  k = nzb, nzt
+                       sums_wsss_ws_l(k,tn) = sums_wsss_ws_l(k,tn)          &
+                        + ( flux_t(k) + diss_t(k) )                           &
+                        *   weight_substep(intermediate_timestep_count)
+                    ENDDO   
+                                   
 
               END SELECT
Index: palm/trunk/SOURCE/average_3d_data.f90
===================================================================
--- palm/trunk/SOURCE/average_3d_data.f90	(revision 1959)
+++ palm/trunk/SOURCE/average_3d_data.f90	(revision 1960)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Treat humidity and passive scalar separately
 ! 
 ! Former revisions:
@@ -498,4 +498,11 @@
              ENDDO
 
+          CASE ( 'ssws*' )
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
+                   ssws_av(j,i) = ssws_av(j,i) / REAL( average_count_3d, KIND=wp )
+                ENDDO
+             ENDDO
+
           CASE ( 't*' )
              DO  i = nxlg, nxrg
Index: palm/trunk/SOURCE/boundary_conds.f90
===================================================================
--- palm/trunk/SOURCE/boundary_conds.f90	(revision 1959)
+++ palm/trunk/SOURCE/boundary_conds.f90	(revision 1960)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Treat humidity and passive scalar separately
 ! 
 ! Former revisions:
@@ -135,16 +135,15 @@
     USE arrays_3d,                                                             &
         ONLY:  c_u, c_u_m, c_u_m_l, c_v, c_v_m, c_v_m_l, c_w, c_w_m, c_w_m_l,  &
-               dzu, e_p, nr_p, pt, pt_p, q, q_p, qr_p, sa, sa_p,               &
+               dzu, e_p, nr_p, pt, pt_p, q, q_p, qr_p, s, s_p, sa, sa_p,       &
                u, ug, u_init, u_m_l, u_m_n, u_m_r, u_m_s, u_p,                 &
                v, vg, v_init, v_m_l, v_m_n, v_m_r, v_m_s, v_p,                 &
-               w, w_p, w_m_l, w_m_n, w_m_r, w_m_s,&
-               pt_init
+               w, w_p, w_m_l, w_m_n, w_m_r, w_m_s, pt_init
 
     USE control_parameters,                                                    &
-        ONLY:  bc_pt_t_val, bc_q_t_val, constant_diffusion,                    &
+        ONLY:  bc_pt_t_val, bc_q_t_val, bc_s_t_val, constant_diffusion,        &
                cloud_physics, dt_3d, humidity,                                 &
-               ibc_pt_b, ibc_pt_t, ibc_q_b, ibc_q_t, ibc_sa_t, ibc_uv_b,       &
-               ibc_uv_t, inflow_l, inflow_n, inflow_r, inflow_s,               &
-               intermediate_timestep_count, large_scale_forcing,               &
+               ibc_pt_b, ibc_pt_t, ibc_q_b, ibc_q_t, ibc_s_b, ibc_s_t,         &
+               ibc_sa_t, ibc_uv_b, ibc_uv_t, inflow_l, inflow_n, inflow_r,     &
+               inflow_s, intermediate_timestep_count, large_scale_forcing,     &
                microphysics_seifert, nest_domain, nest_bound_l, nest_bound_s,  &
                nudging, ocean, outflow_l, outflow_n, outflow_r, outflow_s,     &
@@ -302,7 +301,7 @@
 
 !
-!-- Boundary conditions for total water content or scalar,
+!-- Boundary conditions for total water content,
 !-- bottom and top boundary (see also temperature)
-    IF ( humidity  .OR.  passive_scalar )  THEN
+    IF ( humidity )  THEN
 !
 !--    Surface conditions for constant_humidity_flux
@@ -344,4 +343,32 @@
        ENDIF
     ENDIF
+!
+!-- Boundary conditions for scalar,
+!-- bottom and top boundary (see also temperature)
+    IF ( passive_scalar )  THEN
+!
+!--    Surface conditions for constant_humidity_flux
+       IF ( ibc_s_b == 0 ) THEN
+          DO  i = nxlg, nxrg
+             DO  j = nysg, nyng
+                s_p(nzb_s_inner(j,i),j,i) = s(nzb_s_inner(j,i),j,i)
+             ENDDO
+          ENDDO
+       ELSE
+          DO  i = nxlg, nxrg
+             DO  j = nysg, nyng
+                s_p(nzb_s_inner(j,i),j,i) = s_p(nzb_s_inner(j,i)+1,j,i)
+             ENDDO
+          ENDDO
+       ENDIF
+!
+!--    Top boundary
+       IF ( ibc_s_t == 0 ) THEN
+          s_p(nzt+1,:,:) = s(nzt+1,:,:)
+       ELSEIF ( ibc_s_t == 1 ) THEN
+          s_p(nzt+1,:,:) = s_p(nzt,:,:)   + bc_s_t_val * dzu(nzt+1)
+       ENDIF
+
+    ENDIF    
 !
 !-- In case of inflow or nest boundary at the south boundary the boundary for v
@@ -381,5 +408,5 @@
        pt_p(:,nys-1,:)     = pt_p(:,nys,:)
        IF ( .NOT. constant_diffusion     )  e_p(:,nys-1,:) = e_p(:,nys,:)
-       IF ( humidity  .OR.  passive_scalar )  THEN
+       IF ( humidity )  THEN
           q_p(:,nys-1,:) = q_p(:,nys,:)
           IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
@@ -388,8 +415,9 @@
           ENDIF
        ENDIF
+       IF ( passive_scalar )  s_p(:,nys-1,:) = s_p(:,nys,:)
     ELSEIF ( outflow_n )  THEN
        pt_p(:,nyn+1,:)     = pt_p(:,nyn,:)
        IF ( .NOT. constant_diffusion     )  e_p(:,nyn+1,:) = e_p(:,nyn,:)
-       IF ( humidity  .OR.  passive_scalar )  THEN
+       IF ( humidity )  THEN
           q_p(:,nyn+1,:) = q_p(:,nyn,:)
           IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
@@ -398,8 +426,9 @@
           ENDIF
        ENDIF
+       IF ( passive_scalar )  s_p(:,nyn+1,:) = s_p(:,nyn,:)
     ELSEIF ( outflow_l )  THEN
        pt_p(:,:,nxl-1)     = pt_p(:,:,nxl)
        IF ( .NOT. constant_diffusion     )  e_p(:,:,nxl-1) = e_p(:,:,nxl)
-       IF ( humidity  .OR.  passive_scalar )  THEN
+       IF ( humidity )  THEN
           q_p(:,:,nxl-1) = q_p(:,:,nxl)
           IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
@@ -408,8 +437,9 @@
           ENDIF
        ENDIF
+       IF ( passive_scalar )  s_p(:,:,nxl-1) = s_p(:,:,nxl)
     ELSEIF ( outflow_r )  THEN
        pt_p(:,:,nxr+1)     = pt_p(:,:,nxr)
        IF ( .NOT. constant_diffusion     )  e_p(:,:,nxr+1) = e_p(:,:,nxr)
-       IF ( humidity .OR. passive_scalar )  THEN
+       IF ( humidity )  THEN
           q_p(:,:,nxr+1) = q_p(:,:,nxr)
           IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
@@ -418,4 +448,5 @@
           ENDIF
        ENDIF
+       IF ( passive_scalar )  s_p(:,:,nxr+1) = s_p(:,:,nxr)
     ENDIF
 
